| Furniture : fns to flesh out the living area .
| Require CoSy APL object vocabulary .
| Author: Bob Armstrong / www.CoSy.com
| Reva's license terms also apply to this file.

cr ." | Furniture begin | "


`( Type0 TypeC TypeI TypeFl TypeS TypeV TypeA TypeFv )` dup+
 { van eval _iv } eachM> ' cL across  over refs-ok  cL  R ` Types v!

| file fns with CoSy args
 
: Fcreate ( fn -- fileid ) dup van fcreate ref0del ; 
 
: Fwrite ( dat fn -- )  over van --abca van foc >r> write r> close 2ref0del ;
 
: Foverwrite ( str fn ) over van --abca van foverwrite  2ref0del ;
 
: ^slurp^ ( str -- str ) >r> van slurp r> ref0del --aab str swap nakedfree ;
| Like "slurp" but takes and returns CoSy strings and frees original .


: shell> ( str -- str ) dup van shell$ --aab str swap free swap ref0del ;
 | like shell but returns any output .

: (spool)^  (spool) str ;

: www ( str -- )  R s" BROWSER" v@  | open URL in BROWSER  
  swap cL shell> ;

: VMn ( str -- list_of_strings_split_on_cr ) "lf toksplt ;
|  name from APL Vector to Matrix on "newlines" .

: WSb ( str -- bool_of_WhiteSpace ) { 33 <I _iv } eachM> ['] cL across ;

: WScut ( str -- list_of_strings_split_on_WhiteSpace ) dup WSb & cut ;

: WStable ( str -- table ) ev temp ! 
 VMn { WScut enc temp @ swap cL temp ! } eachM temp @ ;
|  converts string containing table , eg read off browser screen , to CoSy
| list of lists splitting rows on "cr"s and columns on any white space .


| \/ \/ \/ Stack made with CoSy obs \/ \/ \/ |
ev refs+> variable, stk			| set stk to an empty vector 

: p ( obj -- ) stk @ cL  stk rplc ;		| push 

: P ( -- obj ) stk @			| pop
   dup i# 0if drop ev refs+> ;then		| if empty return empty
   dup dsc  swap i1 _   stk rplc  dup refs-ok ; 
| /\ /\ /\ Stack made with CoSy obs /\ /\ /\ |

| ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ | 
| \/ \/ | Time Fns | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |

: ymdhms_ time&date _ymdhms_ ;
: _ymdhms _ymdhms_ str ; 
: ymdhms ( -- yyyymmdd.hhmmss ( string ) time&date _ymdhms ;

| Cut text into day entries ( approximate as can be seen from def . )
: daylncut ( str -- listOFstrings ) "lf s"  | ======================== | " cL tokcut ;

| \/ \/ | partitioned string fns | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |
 
 "nl "nl cL refs+> value emptyLn
 | MS-DOS definition of blank line . must be changed for UNIX \n
 
0 [IF]
: partFind ( phr str delim -- occurances ) | splits str at occurances of delim
	| and returns parts that contain phr .
  toksplt 
  refs+> >r> { "bl cL swap ss dup i# M->I _iv swap free } eachright
  ['] cL across &  r@ swap at r> refs- ;
 
: partFindBl ( phr str -- occurances )  emptyLn partFind ; 
[THEN]

| /\ /\ | partitioned string fns | /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ |


: words> ['] words (spool) str nlfy -2 _i _ dsc  ;	| Does not work in Tui !

: .needs^ ['] .needs (spool) str nlfy i-1  _ dsc ;

: ^!! ( str -- ) dup van shell ref0del ;	| CS version of !! shell execute .

| Convert character vec to integer
: c2i ( cv -- iv ) dup Type@ TypeC <>if ref0del z" must be character " throw ;then
  dup i# intVecInit >aux> 0 ?do dup i ib@ aux@ i ii! loop ref0del aux> ;
 
| Convert integer to character vec 
: i2c ( iv -- cv ) dup Type@ TypeI <>if ref0del z" must be integer " throw ;then
  dup i# byteVecInit >aux> 0 ?do dup i ii@ aux@ i ib! loop ref0del aux> ;


| \/ Calendar \/ | 

: dt time&date 6 s>iv ;

0 [IF]
: _jd ( v_yyyymmdd -- v_julian ) | same as K _jd except 00010101 is 1 instead of 20350101 -> 0 .
 { dtupk   
[THEN]

: DAYLNS ( d m y n -- ) | outputs daylines for begining date + n days . 
 >r date>fixed _iv r> _iota +i { fixed>date dayln type cr } eachM ;
| >r date>fixed _iv r> _iota ['] +i aaply { fixed>date dayln type cr } eachM ;

| \/ \/ \/ MATH \/ \/ \/ |

: favg  dup ['] f+ across swap i# _iv i>f ['] f/ each ;

 : i^n ( i n -- i^n )	| converted from Ruby on
    | http://en.wikipedia.org/wiki/Exponentiating_by_squaring
  dup 0if 2drop 1 ;; then
  1 -rot repeat 
   dup 2 mod
   if --abcab * 2 put 1-
   else swap dup * swap 2/ 
   then 
   dup while   
   2drop ;
   
: p2	( n -- next-higher-power-of-2 )		| for finding mem slots .
  | from  http://ronware.org/reva/viewtopic.php?pid=5865#p5865
  asm{
    shl eax, 1		; multiply by 2
    bsr eax, eax	; get exponent
  }
;

: 2^n? ( n -- bool )	| returns non-zero ( 1 or -1 ) if n power of 2 .
	| from Helmar ; http://ronware.org/reva/viewtopic.php?pid=5871#p5871
  asm{ 	
  cmp eax, 2
  jc .q
  lea ecx, [eax - 1]
  xor ecx, eax
  cmp eax, ecx
  sbb eax, eax
.q:
 } ; 

| ======================================== |

: _rand_ ( n -- a ) dup intVecInit >aux
   0 ?do rand aux@ i ii! loop aux> ; 

: _rand ( n i -- ) | n rands in  i iota .
   dup intVecInit >aux
   0 ?do dup rand um* nip aux@ i ii! loop drop aux> ; 
   
: _perm ( n -- [ random permutation of n items ] )
  dup _iota >aux dup dup _rand 
  swap 0 ?do dup i ii@ aux@ i ii@
  swap aux@ swap ix xchg aux@ i ii! loop free aux> ; 

| ======================================== |

| Split integer vec into positives and negatives 
: +-splt ( iv -- v ) 1p> i0 >i refs+> >r> & L@ swap at 
	L@ r@ i0 =i & at ,L  r> refs- ; 

| /\ /\ /\ |  MATH  | /\ /\ /\ |

| \/ \/ \/ |  REF COUNTING  | \/ \/ \/ |

  0 _i 64 K* _take refs+> value AFbuf
variable AFptr 

: AFbufON ( -- ) 
	| note not modulo . subject to overflow . 
 { dup AFbuf vbody AFptr @>+! c+ ! } >defer AT+>
 { negate AT+> negate } >defer FT+> ;  | - adr  for freeing
 
: AFbufOFF ( -- ) undo AT+>  undo FT+> ;

: AF1 AFptr off  AFbufON ; 		: AF0 AFbufOFF ; 	: AF> AFbuf AFptr @ _take ; 

| /\ /\ /\ |  REF COUNTING  | /\ /\ /\ |

|  : ref " notepad \\cosy\\ref.txt" shell ;

| display var in  res  
: $^  ( sym -- ) dup+ " source" (sym)  R " res" (sym)  ;

| save res to value of 
| : saveres ( -- ) ;


| \/ \/ | OPERATORS | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |

: ~=\ ( list -- bool ( not_equal scan )   ;
  
| /\ /\ | OPERATORS | /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ |

." | Furniture end | "

